'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

// TODO: Type Checking should be able to take the
//       return value of the check fn and provide the
//       inferred type to the invoke fns.
function runTests(_tests) {
  var results = [];

  var tests = _tests;

  while (typeof tests === 'function') {
    tests = tests();
  }

  if (!tests) {
    return results;
  }

  tests = [].concat(_toConsumableArray(tests));

  var _loop = function _loop() {
    // Flow Ignore required as it does not properly
    // handle multiple tuple refinement, although the
    // type itself is sound and it handles it other than
    // throwing the error.
    var _tests$shift = tests.shift(),
        _tests$shift2 = _slicedToArray(_tests$shift, 3),
        check = _tests$shift2[0],
        invokes = _tests$shift2[1],
        elseinvokes = _tests$shift2[2];

    if (typeof check === 'function') {
      check = check();
    }
    if (check) {
      if (typeof invokes === 'function') {
        results.push(invokes(check));
      } else if (Array.isArray(invokes)) {
        invokes.filter(Boolean).forEach(function (invoke) {
          return typeof invoke === 'function' ? results.push(invoke(check)) : results.push(invoke);
        });
      } else if (invokes) {
        results.push(invokes);
      }
    } else if (elseinvokes) {
      if (typeof elseinvokes === 'function') {
        results.push(elseinvokes(check));
      } else if (Array.isArray(elseinvokes)) {
        elseinvokes.filter(Boolean).forEach(function (invoke) {
          return typeof invoke === 'function' ? results.push(invoke(check)) : results.push(invoke);
        });
      } else if (elseinvokes) {
        results.push(elseinvokes);
      }
      return 'break';
    } else {
      return 'break';
    }
  };

  while (tests.length) {
    var _ret = _loop();

    if (_ret === 'break') break;
  }
  return results;
}

function invokeReduce() {
  for (var _len = arguments.length, tests = Array(_len), _key = 0; _key < _len; _key++) {
    tests[_key] = arguments[_key];
  }

  return tests.reduce(function (p, c) {
    return p.concat(runTests(c));
  }, []);
}

function invokeMap() {
  for (var _len2 = arguments.length, tests = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    tests[_key2] = arguments[_key2];
  }

  return tests.map(function (test) {
    return runTests(test);
  });
}

function invokeAny() {
  for (var _len3 = arguments.length, tests = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    tests[_key3] = arguments[_key3];
  }

  return tests.reduce(function (p, c) {
    return p.concat(runTests([c]));
  }, []);
}

exports.default = invokeReduce;
exports.invokeMap = invokeMap;
exports.invokeReduce = invokeReduce;
exports.invokeAny = invokeAny;